routes/web.php
<?php

use App\Models\Consult\ConsultTypesStatus;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', function () {
//    return view('welcome');
//});

//Auth::routes();

/*
 *  Auth routes -> begin
 */

// Authentication Routes...
Route::get('login', [
    'as' => 'login',
    'uses' => 'Auth\LoginController@showLoginForm'
]);
Route::post('login', [
    'as' => '',
    'uses' => 'Auth\LoginController@login'
]);
Route::post('logout', [
    'as' => 'logout',
    'uses' => 'Auth\LoginController@logout'
]);

// Password Reset Routes...
Route::post('password/email', [
    'as' => 'password.email',
    'uses' => 'Auth\ForgotPasswordController@sendResetLinkEmail'
]);
Route::get('password/reset', [
    'as' => 'password.request',
    'uses' => 'Auth\ForgotPasswordController@showLinkRequestForm'
]);
Route::post('password/reset', [
    'as' => 'password.update',
    'uses' => 'Auth\ResetPasswordController@reset'
]);
Route::get('password/reset/{token}', [
    'as' => 'password.reset',
    'uses' => 'Auth\ResetPasswordController@showResetForm'
]);

// Registration Routes...
/*
 * register->login
 */
Route::get('register', [
    'as' => 'register',
    'uses' => 'Auth\LoginController@showLoginForm'
]);
Route::post('register', [
    'as' => '',
    'uses' => 'Auth\LoginController@showLoginForm'
]);

/*
 * Default routes
Route::get('register', [
    'as' => 'register',
    'uses' => 'Auth\RegisterController@showRegistrationForm'
]);
Route::post('register', [
    'as' => '',
    'uses' => 'Auth\RegisterController@register'
]);

*/

/*
 * Auth routes -> ends
 */


Route::get('/', 'Home\HomeController@index')->name('home');
Route::get('/home', 'Home\HomeController@index')->name('home');

Route::namespace('Administrator')->prefix('administrator')->name('administrator.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/administrator', 'AdministratorController',
            [
                'except' => []
            ]);
    });

Route::namespace('Roles')->prefix('roles')->name('roles.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/roles', 'RolesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Tags')->prefix('tags')->name('tags.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/keywords', 'KeywordsController',
            [
                'except' => []
            ]);
    });

Route::namespace('Tags')->prefix('tags')->name('tags.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/tags', 'TagsController',
            [
                'except' => []
            ]);
    });

Route::namespace('Tags')->prefix('tags')->name('tags.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/index', 'IndexTagsController',
            [
                'except' => []
            ]);
    });

Route::namespace('Recipes')->prefix('recipes')->name('recipes.')
    ->middleware('can:administration')->group(function () {
        Route::get('/recipes/{recipes:slug}', 'RecipesController@show');
    });

Route::namespace('Recipes')->prefix('recipes')->name('recipes.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/recipes', 'RecipesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Recipes')->prefix('recipes')->name('recipes.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/posts', 'ProductsController',
            [
                'except' => []
            ]);
    });;
//
//Route::namespace('Recipes')->prefix('recipes')->name('recipes.')
//    ->middleware('can:administration')->group(function (){
//        Route::get('/types/{type:slug}', 'TypesController@show');
//    });

Route::namespace('Recipes')->prefix('recipes')->name('recipes.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/types', 'TypesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::get('/recipes/{recipe:slug|id}', 'DraftRecipesController@show');
    });

Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/recipes', 'DraftRecipesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/types', 'DraftsTypesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/posts', 'DraftProductsController',
            [
                'except' => []
            ]);
    });

Route::namespace('Users')->prefix('users')->name('users.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/users', 'UsersController',
            [
                'except' => []
            ]);
    });

Route::namespace('Users')->prefix('users')->name('users.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/password', 'PasswordController',
            [
                'except' => []
            ]);
    });

Route::namespace('Users')->prefix('users')->name('users.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/profile', 'ProfilesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Home')->prefix('home')->name('home.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/home', 'HomeController',
            [
                'except' => []
            ]);
    });

//Route::namespace('Home')->prefix('home')->name('home.')
//    ->middleware('can:administration')->group(function (){
//    Route::resource('/contacts', 'ContactUsController',
//        [
//            'except' => []
//        ]);
//});

Route::namespace('Images')->prefix('images')->name('images.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/images', 'ImagesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Ratings')->prefix('ratings')->name('ratings.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/ratings', 'RatingsController',
            [
                'except' => []
            ]);
    });

Route::namespace('Ratings')->prefix('ratings')->name('ratings.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/values', 'RatingValuesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Comments')->prefix('comments')->name('comments.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/comments', 'CommentsController',
            [
                'except' => []
            ]);
    });

Route::namespace('Comments')->prefix('comments')->name('comments.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/values', 'RatingCommentsValuesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Books')->prefix('books')->name('books.')
    ->middleware('can:administration')->group(function () {
        Route::get('/books/create', 'BooksController@create');
    });

Route::namespace('Books')->prefix('books')->name('books.')
    ->middleware('can:administration')->group(function () {
        Route::get('/books/{books:slug}', 'BooksController@show');
    });

Route::namespace('Books')->prefix('books')->name('books.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/books', 'BooksController',
            [
                'except' => []
            ]);
    });

Route::namespace('Books')->prefix('books')->name('books.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/buy', 'BuyFromController',
            [
                'except' => []
            ]);
    });

Route::namespace('Subscribers')->prefix('subscribers')->name('subscribers.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/subscribers', 'SubscribersController',
            [
                'except' => []
            ]);
    });


/*
 * Publish routes
 */


Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/publish', 'PublishController',
            [
                'except' => ['index', 'show', 'edit', 'destroy', 'create', 'store']
            ]);
    });

Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/preparing', 'PreparingController',
            [
                'except' => ['index', 'show', 'edit', 'destroy', 'create', 'store']
            ]);
    });


Route::group(['middleware' => ['can:administration', 'archive']], function () {

        Route::get('/analyst/archive', 'Administrator\AnalystController@archive')
            ->name('analyst.archive');

app/Http/Controllers/Tags/IndexTagsController.php
<?php

namespace App\Http\Controllers\Tags;

use App\Http\Controllers\Controller;
use App\Models\IndexTag;
use App\Models\Tag;
use App\Repositories\TagsRepositoryInterface;
use App\Repositories\TrafficRepositoryInterface;
use Illuminate\Http\Request;

class IndexTagsController extends Controller
{
    /**
     * @var TrafficRepositoryInterface
     */
    private $trafficRepository;
    /**
     * @var TagsRepositoryInterface
     */
    private $tagsRepository;

    public function __construct(TrafficRepositoryInterface $trafficRepository, TagsRepositoryInterface $tagsRepository)
    {
        $this->trafficRepository = $trafficRepository;
        $this->tagsRepository = $tagsRepository;
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        $action = 'index';
        $this->trafficRepository->getRemoteAddress($action);

        return redirect()->route('tags.tags.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $action = 'create';
        $this->trafficRepository->getRemoteAddress($action);

        return redirect()->route('tags.tags.index');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $action = 'store';
        $this->trafficRepository->getRemoteAddress($action);

        $this->tagsRepository->addIndexTag($request);

        return redirect()->route('tags.tags.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\IndexTag  $index
     */
    public function show(IndexTag $index)
    {

        $action = 'show';
        $this->trafficRepository->getRemoteAddress($action);

        return view('tags.tags.index-tag-show')->with('tag', $index);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\IndexTag  $indexTag
     * @return \Illuminate\Http\Response
     */
    public function edit(IndexTag $indexTag)
    {
        $action = 'edit';
        $this->trafficRepository->getRemoteAddress($action);

        return redirect()->route('tags.tags.index');
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\IndexTag  $indexTag
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, IndexTag $index)
    {
        $action = 'update';
        $this->trafficRepository->getRemoteAddress($action);

        if($request->name == $index->name){
            $validated = $request->validate(
                [
                    'name' => 'required',
                ]
            );
        } else {
            $validated = $request->validate(
                [
                    'name' => 'required|unique:tags|min:3|max:100',
                ]
            );
        }
        $index->update(
            [
                'name' => $validated['name'],
            ]
        );

        return redirect()->back();
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\IndexTag  $indexTag
     * @return \Illuminate\Http\Response
     */
    public function destroy(IndexTag $index)
    {
        $action = 'update';
        $this->trafficRepository->getRemoteAddress($action);

        $index->delete();

        return redirect()->route('tags.tags.index');
    }
}

app/Http/Controllers/Tags/KeywordsController.php
<?php

namespace App\Http\Controllers\Tags;

use App\Http\Controllers\Controller;
use App\Models\Keyword;
use App\Repositories\KeywordRepositoryInterface;
use App\Repositories\TrafficRepositoryInterface;
use Illuminate\Http\Request;

class KeywordsController extends Controller
{
    /**
     * @var TrafficRepositoryInterface
     */
    private $trafficRepository;
    /**
     * @var KeywordRepositoryInterface
     */
    private $keywordRepository;

    public function __construct(TrafficRepositoryInterface $trafficRepository, KeywordRepositoryInterface $keywordRepository)
    {
        $this->trafficRepository = $trafficRepository;
        $this->keywordRepository = $keywordRepository;
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $action = 'index';
        $this->trafficRepository->getRemoteAddress($action);

        $keywords = $this->keywordRepository->getAllKeywords();
        return view('tags.keywords.index')->with('keywords', $keywords);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $action = 'create';
        $this->trafficRepository->getRemoteAddress($action);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $action = 'store';
        $this->trafficRepository->getRemoteAddress($action);

        $keywords = $this->keywordRepository->addNewKeyword($request);

        if (!empty($keywords)) {
            $request->session()->flash('success', 'The keyword is successfully added!');
        } else {
            $request->session()->flash('danger', 'There was an error adding the keyword');
        }

        return redirect()->route('tags.keywords.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Keyword  $keyword
     * @return \Illuminate\Http\Response
     */
    public function show(Keyword $keyword)
    {
        $action = 'show';
        $this->trafficRepository->getRemoteAddress($action);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Keyword  $keyword
     * @return \Illuminate\Http\Response
     */
    public function edit(Keyword $keyword)
    {
        $action = 'edit';
        $this->trafficRepository->getRemoteAddress($action);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Keyword  $keyword
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Keyword $keyword)
    {
        $action = 'update';
        $this->trafficRepository->getRemoteAddress($action);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Keyword  $keyword
     * @return \Illuminate\Http\Response
     */
    public function destroy(Keyword $keyword, Request $request)
    {
        $action = 'destroy';
        $this->trafficRepository->getRemoteAddress($action);

        $delete = $this->keywordRepository->deleteExistingKeyword($keyword);

        if ($delete === TRUE) {
            $request->session()->flash('success', 'The keyword is successfully deleted!');
        } else {
            $request->session()->flash('danger', 'There was an error deleting the keyword');
        }

        return redirect()->route('tags.keywords.index');
    }
}

resources/views/tags/keywords/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="alert alert-warning" role="alert">
            Ключовите думи, подобно на таговете, са важни, за да може да се индексира правилно всеки един сайт в търсачките (гугъл, бинг и т.н.) В контролния панел има възможност за добавяне на ключови думи. При добавяне на нова рецепта в драфт, задължително трябва да се изберат всички ключови, които отговарят на рецептата. Ако няма такива, трябва да се създадат от полето долу. Добавя се както изписана на български, така и на английски.
        </div>
    </div>
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <div class="container">
                    <div class="row">
                        <div class="col-md-8">
                            <div class="card my-3 mx-auto">
                                <div class="card-header">
                                    <h4 align="center">
                                        Списък на съществуващите ключови думи:
                                    </h4>
                                </div>
                                <div class="card-body">
                                    <td class="card-group">
                                        <table class="table table-hover">
                                            <thead>
                                            <tr>
                                                <th>#</th>
                                                <th>Дума</th>
                                                <th>Дума на латиница</th>
                                                <th>Действия</th>
                                            </tr>
                                            </thead>
                                            <tbody>
                                                @if($keywords->count()>0)
                                                    @foreach($keywords as $keyword)
                                                        <tr>
                                                        <td>{{$keyword->id}}</td>
                                                        <td><a href="{{ route('tags.keywords.show', $keyword->id) }}">{{$keyword->name}}</a></td>
                                                        <td><a href="{{ route('tags.keywords.show', $keyword->id) }}">{{$keyword->eng_name}}</a></td>
                                                            <td>
                                                                <form action="{{route('tags.keywords.destroy', $keyword->id)}}" method="POST">
                                                                    @csrf
                                                                    {{ method_field('DELETE') }}
                                                                    <button type="submit" class="btn btn-outline-dark">
                                                                        Изтрий
                                                                    </button>
                                                                </form>
                                                            </td>
                                                        </tr>
                                                    @endforeach
                                                @endif
                                            </tbody>
                                        </table>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-4 my-3">
                            <div class="well">
                                <h4 align="center">
                                    <label>
                                        Добави нова ключова дума
                                    </label>
                                </h4>
                                <form action="{{ route('tags.keywords.store') }}" method="POST">
                                    @csrf

                                    <div class="card">
                                        <div class="card-header">
                                            <label for="name">
                                                Наименование:
                                            </label>
                                        </div>
                                        <div class="card-body">
                                            <h5>
                                                <input id="name"
                                                       type="text"
                                                       class="form-control @error('name') is-invalid @enderror"
                                                       name="name"
                                                       value="{{ old('name') }}"
                                                       required autocomplete="name" autofocus>
                                                @error('name')
                                                <br>
                                                <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                                @enderror
                                            </h5>
                                        </div>
                                    </div>
                                    <div class="card">
                                        <div class="card-header">
                                            <label for="eng_name">
                                                Наименование на латиница:
                                            </label>
                                        </div>
                                        <div class="card-body">
                                            <h5>
                                                <input id="eng_name"
                                                       type="text"
                                                       class="form-control @error('eng_name') is-invalid @enderror"
                                                       name="eng_name"
                                                       value="{{ old('eng_name') }}"
                                                       required autocomplete="eng_name" autofocus>
                                                @error('eng_name')
                                                <br>
                                                <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                                @enderror
                                            </h5>
                                        </div>
                                    </div>
                                    <div class="d-flex justify-content-center m-2">
                                        <button type="submit" class="btn btn-dark">
                                            Добави
                                        </button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection